#include "lib.lua"

local sliding = false
local justPressed = false
local validSlideInput = false
local boostVel = nil

destmult = FGetFloat("savegame.mod.movement.destruction", 1)
local basemovebuff = FGetFloat("savegame.mod.movement.speedboost", 100)

meleepower = 1--1.25 -- requires compatible weapon models :(
enablemelee = false -- requires compatible weapon models :(
local meleerange = 3
local meleemult = 8
local flashlight
local meleetimer = 0
local meleeduration = 0.5

-- Properties
-- Slide
local curveDragAmount = 0.1
local aerialDragMult = 0.6
local directionInputSpeed = 3
local aerialMovementMult = 0.4
local minSpeedToStart = 4
local minSpeedToContinue = FGetFloat("savegame.mod.movement.slide.speed", 4.5)*2-1
local forceVal = FGetFloat("savegame.mod.movement.slide.speed", 4.5)
local speedVal = FGetFloat("savegame.mod.movement.slide.startspeed", 12.5)
local impactSlowdown = 0.985
local dragVal = FGetFloat("savegame.mod.movement.slide.drag", 0.7)


-- Impact Descrution
local impactDamage = FGetFloat("savegame.mod.movement.damage.amount", 0.25) --Damage to player
local impactDamageKills = FGetBool("savegame.mod.movement.damage.allowkill", false)
local preventStuck = true
local stepUpMult = 0.3

local healthBuffer = 0.1
local maxHealthBuffer = 0.1

-- Ground Pound
local enableGP = FGetBool("savegame.mod.movement.groundpound.enabled", true)
local GPspeedMult = 0.2
local GPdownImpulse = 15
local GPdownForce = 45
local GPactive = false

-- RedTide
local enableRedTide = FGetBool("savegame.mod.movement.redtide.enabled", true)
local crackTimer = 0
local crackTimerMax = 20
local crackAmmo = 4
local crackDuration = 5
local crackSpeed = 300
crackGroup = 5


-- Variables
local volume = 0
local lastPosition = Vec(0,0,0)
local startVelFreshness = 1
local impactDamageOverlay = 0

local steroidBuff = FGetBool("savegame.mod.movement.steroidbuff.enabled", true)
local steroidBuffSpeed = 400 + basemovebuff

local hitSoundsMetal
local hitSoundsRock

local slideSoundRock =LoadLoop("masonry/slide-s-loop.ogg")
local slideSoundMetal =LoadLoop("metal/slide-m-loop.ogg")
local slideSoundWood =LoadLoop("wood/slide-m-loop.ogg")
local slideSoundDirt =LoadLoop("dirt/slide-m-loop.ogg")
local slideSoundPlastic =LoadLoop("plastic/slide-m-loop.ogg")
local slideSoundPlaster =LoadLoop("masonry/slide-l-loop.ogg")
local slideSoundFoliage =LoadLoop("foliage/slide-m-loop.ogg")
local slideSoundGlass =LoadLoop("glass/slide-s-loop.ogg")
local snd = LoadLoop("MOD/snd/slide.ogg")
local crackSound = LoadSound("MOD/snd/drink.ogg")
local crackLoop = LoadLoop("MOD/snd/heartbeat.ogg")
local speedLoop = LoadLoop("MOD/snd/speed.ogg")
hitSoundsMetal = {}
for i=0, 5 do
	hitSoundsMetal[i] = LoadSound("metal/hit-l"..i..".ogg")
end
hitSoundsRock = {}
for i=0, 5 do
	hitSoundsRock[i] = LoadSound("masonry/hit-l"..i..".ogg")
end

local framecount = 0

local groundMaterialType

function movement_init()
	if enableRedTide then
		RegisterTool("crack", "RedTide", "MOD/vox/crack.vox", crackGroup)
		SetBool("game.tool.crack.enabled", true)
		SetFloat("game.tool.crack.ammo", crackAmmo)
		SetFloat("game.player.crack", 0)
	end
end

local height = 1 --Approximate player height


local curveDragCurrent = 0

--Melee
local meleeoffset = 0
local meleeoffsetv = 0
local meleequeued = false
local meleesound = LoadSound("MOD/snd/melee.ogg")

function movement_tick(dt)
	-- Detect flashlight
	if enablemelee and flashlight == nil then
		local lights = FindLights(nil, true)
		for i=1, #lights do
			if VecLength(VecSub(GetLightTransform(lights[i]).pos, GetPlayerTransform().pos)) <= 1.5 then
				flashlight = lights[i]
				break
			end
		end
	end

	-- Melee (here be jank)
	if enablemelee then
		SetLightEnabled(flashlight, false)
		-- Do melee
		if InputDown("flashlight") or meleequeued then
			if meleetimer <= 0 then 
				if abs(meleeoffset) < 0.02 then
					PlaySound(meleesound)
					meleetimer = meleeduration
					meleequeued= false
				elseif abs(meleeoffset) < 0.2 then
					meleequeued = true
				end
			end
		end
		if meleetimer > 0 then
			meleetimer = meleetimer - dt
			if meleetimer <= 0 then
				doMelee(dt)
			end
		end

		-- Melee animation (compatible models only!)
		local t = 1-(meleetimer/meleeduration)

		local wpnoffset = Vec()
		if GetString("game.player.tool") == "rocket" then
			wpnoffset = Vec(-0.4, 0, 0)
		elseif GetString("game.player.tool") == "crack" then
			wpnoffset = Vec(0.4, -0.7, -0.2)
		elseif GetString("game.player.tool") == "grapplegun" then
			wpnoffset = Vec(0.4, -0.7, -0.2)
		elseif GetString("game.player.tool") == "steroid" then
			wpnoffset = Vec(0.0, -0.3, 0)
		end

		if meleetimer <= 0 then 
			meleeoffset = meleeoffset * (1-dt*10)
			meleeoffsetv = meleeoffsetv * (1-dt*1)
		elseif t < 0.7 then
			meleeoffset = t*-1
			meleeoffsetv = meleeoffsetv + (8.5-meleeoffsetv) * (dt*5)
		else
			meleeoffset = -0.5+(t-0.7)^2*20
			meleeoffsetv = meleeoffsetv + (7.5-meleeoffsetv) * (dt*10)
		end
		if #GetBodyShapes(GetToolBody()) > 1 then
			local fistshape = GetBodyShapes(GetToolBody())[#GetBodyShapes(GetToolBody())]

			DrawShapeHighlight(fistshape, meleeoffset*0.1)
			DrawShapeOutline(fistshape, 1.0,1.0,1.0,(meleeoffsetv*0.06)^2)

			local localtrans = Transform(VecAdd(wpnoffset,Vec(-1.0+meleeoffset*0.1,-0.4+meleeoffsetv*0.1,-0.8-meleeoffset*0.5)),QuatEuler(0,meleeoffset,-meleeoffsetv*3+meleeoffset*8))
			SetShapeLocalTransform(fistshape, localtrans)
		end
	end

	-- RedTide
	if GetString("game.player.tool") == "crack" and GetPlayerVehicle() == 0 then
		if InputPressed("lmb") and (FGetBool("level.unlimitedammo") or FGetFloat("game.tool.crack.ammo") > 0) and crackTimer < crackTimerMax-crackDuration then
			crackTimer = crackTimer + crackDuration
			SetFloat("game.tool.crack.ammo", FGetFloat("game.tool.crack.ammo")-1)
			PlaySound(crackSound)
		end
	end
	framecount = framecount + 1
	

end

function movement_draw()

	local crack = FGetFloat("game.player.crack",0)
	if crack > 0 then
		UiPush()
			UiColor(1, 0.1, 0.1, (1-abs((crackTimer/2)^1.5%1-0.5))*crack+0.2*crack)
			UiImageBox("MOD/ui/crack.png", UiWidth(), UiHeight(), 0, 0)
		UiPop()
	end
	if impactDamageOverlay>0 then
		UiColor(1,0,0, impactDamageOverlay)
		UiRect(UiWidth(), UiHeight())
	end
end

function movement_update(dt)
	local takenContactDamage = false

	impactDamageOverlay = clampZero(impactDamageOverlay-dt)

	-- Redtide
	if crackTimer > 0 then
		SetFloat("game.player.crack", 1)
		crackTimer = crackTimer - dt
		
		-- Speed boost
		local moveF = InputValue("up")-InputValue("down")
		local moveR = InputValue("right")-InputValue("left")
		moveF = moveF * crackSpeed * dt
		moveR = moveR * crackSpeed * dt

		local dInputVel = Vec(moveR, 0, -moveF)
		dInputVel = TransformToParentVec(GetPlayerCameraTransform(), dInputVel)
		SetPlayerGroundVelocity(dInputVel)

		if crackTimer < 1 then SetFloat("game.player.crack", crackTimer) end
	else
		SetFloat("game.player.crack", 0)
		crackTimer = 0
	end

	-- BlueTide Buff
	if steroidBuff then
		local steroid = FGetFloat("game.player.steroid")
		if steroid > 0 and not sliding then
			local moveF = InputValue("up")-InputValue("down")
			local moveR = InputValue("right")-InputValue("left")
			moveF = moveF * steroidBuffSpeed * dt
			moveR = moveR * steroidBuffSpeed * dt

			local dInputVel = Vec(moveR, 0, -moveF)
			dInputVel = TransformToParentVec(GetPlayerCameraTransform(), dInputVel)
			SetPlayerGroundVelocity(dInputVel)
		end
	end
	if basemovebuff > 0 and not sliding then
		local moveF = InputValue("up")-InputValue("down")
		local moveR = InputValue("right")-InputValue("left")
		moveF = moveF * basemovebuff * dt
		moveR = moveR * basemovebuff * dt

		local dInputVel = Vec(moveR, 0, -moveF)
		dInputVel = TransformToParentVec(GetPlayerCameraTransform(), dInputVel)
		SetPlayerGroundVelocity(dInputVel)
	end

	-- Movement

	-- Stop sliding/GPing when in water
	if IsPointInWater(GetPlayerPosAdjusted()) then
		sliding = false
		if GPactive then
			GPactive = false
			SetPlayerVelocity(VecScale(GetPlayerVelocity, 0.5))
		end
	end

	-- Stop sliding/GPing if motionless or stuck
	local currentPosition = GetPlayerPosAdjusted() 
	local posDelta = VecSub(currentPosition,lastPosition)

	lastPosition = currentPosition
	if preventStuck then
		if VecLength(posDelta) < minSpeedToStart * dt then
			sliding = false
			GPactive = false
		end
	end
	
	local cv = FGetFloat("game.player.crack")/6
	if cv > 1 then cv = 1 end
	PlayLoop(crackLoop, GetPlayerPosAdjusted(), cv)

	startVelFreshness = startVelFreshness + dt/3
	if startVelFreshness > 1 then startVelFreshness = 1 end

	local vel = GetPlayerVelocity()
	PlayLoop(snd, GetPlayerPosAdjusted(), volume*1)
	local type = groundMaterialType
	if type == "brick" or type == "masonry" or type == "rock" or type == "hardmasonry" or type == "concrete" then
		PlayLoop(slideSoundRock, GetPlayerPosAdjusted(), volume*24)
	end
	if type == "metal" or type == "hardmetal" or type == "weakmetal" then
		PlayLoop(slideSoundMetal, GetPlayerPosAdjusted(), volume*24)
	elseif type == "dirt" then
		PlayLoop(slideSoundDirt, GetPlayerPosAdjusted(), volume*24)
	elseif type == "plastic" then
		PlayLoop(slideSoundPlastic, GetPlayerPosAdjusted(), volume*24)
	elseif type == "plaster" then
		PlayLoop(slideSoundPlaster, GetPlayerPosAdjusted(), volume*24)
	elseif type == "foliage" or type == "grass" then
		PlayLoop(slideSoundFoliage, GetPlayerPosAdjusted(), volume*24)
	elseif type == "glass"then
		PlayLoop(slideSoundGlass, GetPlayerPosAdjusted(), volume*24)
	end
	

	local destbuff = 1+FGetFloat("game.player.steroid")*0.125 + FGetFloat("game.player.crack")*2
	local mvmtbuff = 1+FGetFloat("game.player.steroid")*0.8 + FGetFloat("game.player.crack")*0.25

	PlayLoop(speedLoop, GetPlayerPosAdjusted(), saturate((VecLength(GetPlayerVelocity())-9)*0.02))

	--Counteract aerial friction
	if not GetPlayerGrounded() then
		local pvy = vel[2]
		vel = VecScale(vel, 1+dt*0.4)
		vel[2] = pvy
		SetPlayerVelocity(vel)
	end

	--Ignore if in vehicle
	if GetPlayerVehicle() ~= 0 then
		sliding = false
		return 0
	end


	--Check if crouch is pressed
	if InputDown("crouch") then



		local grounded = GetPlayerGrounded()

		if not sliding then
			
			if not GPactive then
				if grounded and validSlideInput then
					local velLen = VecLength(vel)

					if velLen >= minSpeedToStart then
						sliding = true

						if speedVal*startVelFreshness > velLen then
							local velScale = ((speedVal*startVelFreshness - velLen)/velLen)
							if velScale > 1 then velScale = 1 end
							velScale = 1+velScale^3
							if velScale < 1 then velScale = 1 end
							boostVel = VecScale(vel, velScale)
							startVelFreshness = startVelFreshness*0.7
						else
							boostVel = vel
						end
						curveDragCurrent = 0
					end
				else if not GetPlayerNearGround() and justPressed and enableGP then
						if not IsPointInWater(VecAdd(GetPlayerPosAdjusted(),Vec(0,-height,0))) then
							local newVel = vel
							newVel = VecScale(newVel, GPspeedMult)
							newVel[2] = newVel[2] - GPdownImpulse
							SetPlayerVelocity(newVel)
							GPactive = true
						end
					end
				end

			else
				-- Ground Pounding

				local newVel = vel
				newVel[2] = newVel[2] - GPdownForce*dt
				SetPlayerVelocity(newVel)

				
			if grounded then
				GPactive = false
			end
			end
		else
			-- Sliding
			local moveF = InputValue("up")-InputValue("down")
			local moveR = InputValue("right")-InputValue("left")
			moveF = moveF * directionInputSpeed * dt
			moveR = moveR * directionInputSpeed * dt
			if not grounded then moveF = moveF * aerialMovementMult end
			if not grounded then moveR = moveR * aerialMovementMult end
			local moveAmt = abs(moveF)+abs(moveR)
			if (moveAmt > 1) then moveAmt = 1 end


			--apply drag using dt
			local dragMult = 1
			if not grounded then dragMult = dragMult * aerialDragMult end
			if grounded then dragMult = clampZero(vel[2]*0.4+1) end
			boostVel = VecSub(boostVel, VecScale(boostVel, dt * dragVal * dragMult))
			boostVel = VecSub(boostVel, VecScale(boostVel, curveDragCurrent))
			boostVel = VecAdd(boostVel,VecScale(VecNormalize(vel),forceVal*mvmtbuff * dt))

			local dInputVel = Vec(moveR, 0, -moveF)
			dInputVel = TransformToParentVec(GetPlayerCameraTransform(), dInputVel)
			
			dInputVel = VecScale(VecNormalize(Vec(dInputVel[1], 0, dInputVel[3])), moveAmt)
			local newBoostVelNorm = VecNormalize(VecAdd(boostVel, dInputVel))
			local boostDelta = VecLength(VecSub(VecNormalize(boostVel),newBoostVelNorm))
			curveDragCurrent = boostDelta * curveDragAmount
			boostVel = VecScale(newBoostVelNorm, VecLength(boostVel))

			local newVel = Vec(boostVel[1], vel[2], boostVel[3])
			--newVel = Vec(newVel[1], vel[2], newVel[3]) --Remove vert

			SetPlayerVelocity(newVel)

			if VecLength(newVel) < minSpeedToContinue then
				sliding = false
			end

			if grounded then
				volume = volume - dt*10*(volume-(0.01+VecLength(vel)*0.005))
			else
				volume = volume * (1-dt*1.4)^2
			end
		end

		if grounded then validSlideInput = false end
		justPressed = false

	-- Etc
	else
		sliding = false
		justPressed = true
		validSlideInput = true
	end

	if not sliding then
		volume = volume - dt*0.1
	end

	-- Check for collisions
	-- FRONT
	vel = GetPlayerVelocity()
	if vel[2] > -8 then
		local velLen = VecLength(vel)
		local hit, d, normal, shape  = QueryRaycast(GetPlayerPosAdjusted(),VecNormalize(posDelta), velLen*dt*4+height/2, height/4*0.6)
		if hit then
			local impactPoint = VecAdd(GetPlayerPosAdjusted(),VecScale(VecNormalize(vel),d))
			local type = GetShapeMaterialAtPosition(shape, VecAdd(impactPoint,VecScale(VecNormalize(vel), height/4*0.6+0.1)))

			
			if sliding then
				boostVel = VecScale(boostVel,impactSlowdown)
			end

			vel[2] = vel[2]/4 --Reduce launch

			SetPlayerVelocity(vel)
			local vsqrt = clampZero(velLen-3)^2*0.008
			if GPactive then vsqrt=clampZero(velLen-80)^2*0.004 end
			-- if sliding then vsqrt=velLen^2*0.01 end
			if sliding then vsqrt = vsqrt*1.2 end
			vsqrt = vsqrt * destmult
			MakeHole(impactPoint,vsqrt*destbuff, vsqrt*(destbuff-1) + clampZero(vsqrt-0.05)*stepUpMult, velLen/10*(destbuff-2)) 
			AddForce(impactPoint,vsqrt*destbuff, VecScale(vel, 0.4*destbuff))

			vel[2] = 0
			local velLen = VecLength(vel)

			-- Play hit sounds for hard materials (similar to sledge)
			if velLen > 8 then
				local vol = velLen/50
				if vol>0.5 then vol =0.5 end
				if type == "brick" or type == "masonry" or type == "rock" or type == "hardmasonry" or type == "concrete" then
					PlaySound(hitSoundsRock[framecount%#hitSoundsRock], GetPlayerPosAdjusted(), vol)
				end
				if type == "metal" or type == "hardmetal" or type == "weakmetal" then
					PlaySound(hitSoundsMetal[framecount%#hitSoundsMetal], GetPlayerPosAdjusted(), vol)
				end
			end

			if impactDamage > 0 then
				local matMult = 1
				if type == "grass" then matMult = 0.1 end
				if type == "foliage" then matMult = 0.1 end
				if type == "wood" then matMult = 0.75 end
				if type == "dirt" then matMult = 0.4 end
				local resistanceMult = 1+FGetFloat("game.player.steroid")*2 + FGetFloat("game.player.crack")*1
				local dmg = impactDamage*velLen/40/resistanceMult*matMult
				if velLen > 8 and dmg > 0.01 then
					takenContactDamage = true
					if healthBuffer > 0 then
						healthBuffer = healthBuffer - dmg
						if healthBuffer < 0 then dmg = abs(healthBuffer) healthbuffer = 0 end
					end
					if healthBuffer <= 0 then
						local save = 0.01
						if impactDamageKills then save = 0 end
						SetPlayerHealth(clampZero(GetPlayerHealth()-dmg)+save)
						impactDamageOverlay = impactDamageOverlay+impactDamage*matMult*velLen/50/resistanceMult
					end
				end
			end
		end
	end

	if vel[2] < -5 then
		-- GROUND
		-- find ground hit
		local hit, d, normal, shape  = QueryRaycast(GetPlayerPosAdjusted(),Vec(0,-1,0), height*2 - vel[2]*dt, height/4)
		if hit then
			local velLen = -vel[2]
			local impactPoint = VecAdd(GetPlayerPosAdjusted(),VecScale(VecNormalize(newVel),d))
			local vsqrt = clampZero(velLen+4)^2*0.003
			if GPactive then vsqrt=clampZero(velLen-80)^2*0.004 end
			-- if sliding then vsqrt=velLen^2*0.01 end
			vsqrt = vsqrt * destmult * 2.6
			MakeHole(impactPoint,vsqrt*destbuff*0.8, vsqrt*(destbuff-1) + clampZero(vsqrt)*stepUpMult, velLen/10*(destbuff-2)) 
			AddForce(impactPoint,vsqrt*destbuff, VecScale(vel, -2*destbuff)) 

			-- Play hit sounds for hard materials (similar to sledge)
			if velLen > 5 then
				local type = GetShapeMaterialAtPosition(shape, VecAdd(impactPoint,Vec(0,-height*0.6-0.1,0)))

				local vol = velLen/25
				vol = 1
				if vol>0.7 then vol =0.7 end
				if type == "brick" or type == "masonry" or type == "rock" or type == "hardmasonry" or type == "concrete" then
					PlaySound(hitSoundsRock[framecount%#hitSoundsRock], GetPlayerPosAdjusted(), vol)
				end
				if type == "metal" or type == "hardmetal" or type == "weakmetal" then
					PlaySound(hitSoundsMetal[framecount%#hitSoundsMetal], GetPlayerPosAdjusted(), vol)
				end
			end
		end
		
	end

	if not takenContactDamage then
		healthBuffer = healthBuffer+ dt*1
		if healthBuffer > maxHealthBuffer then healthBuffer = maxHealthBuffer end
	end
end

function doMelee(dt)
	local destbuff = 1+FGetFloat("game.player.steroid")*0.2 + FGetFloat("game.player.crack")*2

	startpos = GetPlayerCameraTransform().pos

	vel = GetPlayerVelocity()
	local forwardvector = QuatRotateVec(GetPlayerCameraTransform().rot, Vec(0,0,-1))
	local velLen = VecLength(vel)
	local hit, d, normal, shape  = QueryRaycast(startpos,forwardvector, meleerange+velLen*0.1, height/4*0.6)

	-- DrawLine(startpos, VecAdd(startpos,VecScale(forwardvector,meleerange)))

	if hit then
		local impactPoint = VecAdd(startpos,VecScale(VecNormalize(forwardvector),d))
		local type = GetShapeMaterialAtPosition(shape, VecAdd(impactPoint,VecScale(VecNormalize(forwardvector), height/4*0.6+0.1)))

		
		if sliding then
			boostVel = VecScale(boostVel,impactSlowdown)
		end

		vel[2] = vel[2]/4 --Reduce launch

		SetPlayerVelocity(vel)
		local vsqrt = clampZero(velLen-3)^2*0.008
		if GPactive then vsqrt=clampZero(velLen-80)^2*0.004 end
		-- if sliding then vsqrt=velLen^2*0.01 end
		if sliding then vsqrt = vsqrt*1.2 end
		vsqrt = vsqrt * destmult
		vsqrt = vsqrt * meleemult
		vsqrt = vsqrt + meleepower
		MakeHole(impactPoint,vsqrt*destbuff, vsqrt*(destbuff-1) + clampZero(vsqrt-0.05)*stepUpMult, velLen/10*(destbuff-2)) 
		AddForce(impactPoint,vsqrt*1.2*destbuff, VecAdd(VecScale(forwardvector, 100),VecScale(vel, 0.4*destbuff)))

		vel[2] = 0
		local velLen = VecLength(vel)

		-- Play hit sounds for hard materials (similar to sledge)
		if velLen > 8 then
			local vol = velLen/50
			if vol>0.5 then vol =0.5 end
			if type == "brick" or type == "masonry" or type == "rock" or type == "hardmasonry" or type == "concrete" then
				PlaySound(hitSoundsRock[framecount%#hitSoundsRock], GetPlayerPosAdjusted(), vol)
			end
			if type == "metal" or type == "hardmetal" or type == "weakmetal" then
				PlaySound(hitSoundsMetal[framecount%#hitSoundsMetal], GetPlayerPosAdjusted(), vol)
			end
		end
	end
end


function GetPlayerPosAdjusted()
	if InputDown("crouch") then
		return VecSub(GetPlayerPos(), Vec(0,0.27,0))
	else
		return GetPlayerPos()
	end
end