#include "lib.lua"

function init()
	forceVal = FGetFloat("savegame.mod.movement.slide.speed", 4.5)
	speedVal = FGetFloat("savegame.mod.movement.slide.startspeed", 12.5)
	impactDamage = FGetFloat("savegame.mod.movement.damage.amount", 0.25)
	impactDamageKills = FGetBool("savegame.mod.movement.damage.allowkill", true)
	enableGP = FGetBool("savegame.mod.movement.groundpound.enabled", true)
	enableRedTide = FGetBool("savegame.mod.movement.redtide.enabled", true)
	steroidBuff = FGetBool("savegame.mod.movement.steroidbuff.enabled", true)
	destmult = FGetFloat("savegame.mod.movement.destruction", 1)
	dragVal = FGetFloat("savegame.mod.movement.slide.drag", 0.7)
	basemovebuff = FGetFloat("savegame.mod.movement.speedboost", 100)
end

panelwidth = 800

function draw()


	-- UiTranslate(panelwidth/2, 0)
	-- Presets

	panelwidth = 800
	UiColor(0.08,0.08,0.08)
	UiRect(UiWidth(), UiHeight())
			-- Close button
			UiPush()
			UiFont("regular.ttf", 24)
			
			UiAlign("center middle")
			UiTranslate(UiCenter(), UiHeight()-50)
			
			UiColor(1,1,1,0.9)
			if UiTextButton("Close Settings", panelwidth, 40) then
				Menu()
			end
		UiPop()	
	UiColor(1.0,1.0,1.0)
	-- Title
	UiTranslate(UiCenter(), UiCenter()-860)
	UiAlign("center middle")

	UiFont("bold.ttf", 55)
	UiPush()
		accent()
		UiImage("MOD/ui/banner.png")
	UiPop()
	-- PRESETS
	UiTranslate(0, 60)
	UiFont("bold.ttf", 40)
	UiPush()
		UiTranslate(panelwidth/-2, 0)
		UiFont("bold.ttf", 26)
		UiAlign("left left")
		UiText("Preset Settings")
		UiFont("regular.ttf", 20)
		UiTranslate(0, 27)
		UiText("Recommended is default settings. The fastest way to move is by slide hopping. Includes new RedTide tool.\
		Balanced reduces the slide to be about as fast as walking. Slide hopping no longer gains speed, but still retains it.\
		Overpowered buffs everything, for maximum destruction and speed, meant for sandbox mode.")
		UiAlign("right")
		UiTranslate(panelwidth/2, 0)
	UiPush()
	UiTranslate(panelwidth/-6, 80)
	UiFont("regular.ttf", 23)

	UiPush()
		UiButtonImageBox("ui/common/box-outline-6.png", 6, 6)
		if UiTextButton("Balanced", panelwidth/3, 40) then
			forceVal = 2
			speedVal = 10
			impactDamage = 1
			dragVal = 0.7
			impactDamageKills = false
			enableGP = false
			enableRedTide = false
			steroidBuff = false
			destmult = 0.5
			basemovebuff = 0
			SetFloat("savegame.mod.movement.slide.speed", forceVal)
			SetFloat("savegame.mod.movement.slide.startspeed", speedVal)
			SetFloat("savegame.mod.movement.damage.amount", impactDamage)
			SetBool("savegame.mod.movement.damage.allowkill", impactDamageKills)
			SetBool("savegame.mod.movement.groundpound.enabled", enableGP)
			SetBool("savegame.mod.movement.redtide.enabled", enableRedTide)
			SetBool("savegame.mod.movement.steroidbuff.enabled", steroidBuff)
			SetFloat("savegame.mod.movement.destruction", destmult)
			SetFloat("savegame.mod.movement.slide.drag", dragVal)
			SetFloat("savegame.mod.movement.speedboost", basemovebuff)
		end
	UiPop()
	UiTranslate(panelwidth/3, 0)

	UiPush()
		UiButtonImageBox("ui/common/box-outline-6.png", 6, 6)
		if UiTextButton("Recommended", panelwidth/3, 40) then
			forceVal = 4.5
			speedVal = 12.5
			impactDamage = 0.25
			dragVal = 0.7
			impactDamageKills = true
			enableGP = true
			enableRedTide = true
			steroidBuff = true
			destmult = 1
			basemovebuff = 100

			SetFloat("savegame.mod.movement.slide.speed", forceVal)
			SetFloat("savegame.mod.movement.slide.startspeed", speedVal)
			SetFloat("savegame.mod.movement.damage.amount", impactDamage)
			SetBool("savegame.mod.movement.damage.allowkill", impactDamageKills)
			SetBool("savegame.mod.movement.groundpound.enabled", enableGP)
			SetBool("savegame.mod.movement.redtide.enabled", enableRedTide)
			SetBool("savegame.mod.movement.steroidbuff.enabled", steroidBuff)
			SetFloat("savegame.mod.movement.destruction", destmult)
			SetFloat("savegame.mod.movement.slide.drag", dragVal)
			SetFloat("savegame.mod.movement.speedboost", basemovebuff)

		end
	UiPop()
	UiTranslate(panelwidth/3, 0)
	UiPush()
		UiButtonImageBox("ui/common/box-outline-6.png", 6, 6)
		if UiTextButton("Overpowered", panelwidth/3, 40) then
			forceVal = 6
			speedVal = 25
			impactDamage = 0
			dragVal = 0.5
			impactDamageKills = false
			enableGP = true
			enableRedTide = true
			steroidBuff = true
			destmult = 2.5
			basemovebuff = 250

			SetFloat("savegame.mod.movement.slide.speed", forceVal)
			SetFloat("savegame.mod.movement.slide.startspeed", speedVal)
			SetFloat("savegame.mod.movement.damage.amount", impactDamage)
			SetBool("savegame.mod.movement.damage.allowkill", impactDamageKills)
			SetBool("savegame.mod.movement.groundpound.enabled", enableGP)
			SetBool("savegame.mod.movement.redtide.enabled", enableRedTide)
			SetBool("savegame.mod.movement.steroidbuff.enabled", steroidBuff)
			SetFloat("savegame.mod.movement.destruction", destmult)
			SetFloat("savegame.mod.movement.slide.drag", dragVal)
			SetFloat("savegame.mod.movement.speedboost", basemovebuff)

		end
	UiPop()
	
	UiTranslate(panelwidth/-3*2 + panelwidth/6, 0)

	UiTranslate(panelwidth/2, 20)
	UiImage("MOD/ui/howtoslidehop.png")

	UiTranslate(-panelwidth/2*2, 140)
	UiPush()
		UiFont("bold.ttf", 26)
		UiAlign("left left")
		UiText("Movement Speed Buff")
		UiFont("regular.ttf", 20)
		UiTranslate(0, 18)
		UiText("A static increase in acceleration and speed when not sliding")
		UiAlign("right")
		UiTranslate(panelwidth, 15)
		basemovebuff, done = optionsSlider(basemovebuff, 0, 250, 1)
		UiTranslate(0, -15)
		UiAlign("right right")
		accent()
		UiFont("bold.ttf", 55)
		if basemovebuff==0 then UiColor(0.5,0.5,0.5) end
		UiText(basemovebuff)
		SetFloat("savegame.mod.movement.speedboost", basemovebuff)
	UiPop()

	UiTranslate(0, 60)

	UiPush()
		UiFont("bold.ttf", 26)
		UiAlign("left left")
		UiText("Slide Start Speed")
		UiFont("regular.ttf", 20)
		UiTranslate(0, 18)
		UiText("The initial burst of speed you get when you start sliding")
		UiAlign("right")
		UiTranslate(panelwidth, 15)
		speedVal, done = optionsSlider(speedVal, 10, 25, 0.1)
		UiTranslate(0, -15)
		UiAlign("right right")
		accent()
		UiFont("bold.ttf", 55)
		UiText(speedVal.." m/s")
		SetFloat("savegame.mod.movement.slide.startspeed", speedVal)
	UiPop()

	UiTranslate(0, 60)
	
	UiPush()
		UiFont("bold.ttf", 26)
		UiAlign("left left")
		UiText("Slide Force")
		UiFont("regular.ttf", 20)
		UiTranslate(0, 18)
		UiText("The amount of acceleration constantly applied while sliding, counteracted by drag")
		UiAlign("right")
		UiTranslate(panelwidth, 15)
		forceVal, done = optionsSlider(forceVal, 1, 10, 0.1)
		UiTranslate(0, -15)
		UiAlign("right right")
		accent()
		UiFont("bold.ttf", 55)
		UiText(forceVal.." m/s²")
		SetFloat("savegame.mod.movement.slide.speed", forceVal)
	UiPop()

	UiTranslate(0, 60)
	
	UiPush()
		UiFont("bold.ttf", 26)
		UiAlign("left left")
		UiText("Slide Drag")
		UiFont("regular.ttf", 20)
		UiTranslate(0, 18)
		UiText("The amount of drag constantly applied while sliding, slowing you down")
		UiAlign("right")
		UiTranslate(panelwidth, 15)
		dragVal, done = optionsSlider(dragVal, 0.25, 1, 0.01)
		UiTranslate(0, -15)
		UiAlign("right right")
		accent()
		UiFont("bold.ttf", 55)
		UiText((dragVal*100).."%")
		SetFloat("savegame.mod.movement.slide.drag", dragVal)
	UiPop()
	UiTranslate(0, 60)

	UiPush()
		UiFont("bold.ttf", 26)
		UiAlign("left left")
		UiText("Impact Destruction")
		UiAlign("left left")
		UiFont("regular.ttf", 20)
		UiTranslate(0, 18)
		UiText("The amount of destruction caused by sliding or traveling at high speeds into objects")
		UiAlign("center center")
		UiAlign("right")
		UiTranslate(panelwidth, 15)
		destmult, done = optionsSlider(destmult, 0, 5, 0.1)
		UiTranslate(0, -15)
		UiAlign("right right")
		accent()
		if destmult==0 then UiColor(0.5,0.5,0.5) end
		UiFont("bold.ttf", 55)
		UiText(destmult.."x")
		SetFloat("savegame.mod.movement.destruction", destmult)
	UiPop()

	UiTranslate(0, 60)

	UiPush()
		UiFont("bold.ttf", 26)
		UiAlign("left left")
		UiText("Impact Damage")
		UiAlign("left left")
		UiFont("regular.ttf", 20)
		UiTranslate(0, 18)
		UiText("The amount of health lost by traveling at high speeds into objects")
		UiAlign("center center")
		UiAlign("right")
		UiTranslate(panelwidth, 15)
		impactDamage, done = optionsSlider(impactDamage, 0, 1, 1/40)
		UiTranslate(0, -15)
		UiAlign("right right")
		accent()
		if impactDamage==0 then UiColor(0.5,0.5,0.5) end
		UiFont("bold.ttf", 55)
		UiText((impactDamage*4).."x")
		SetFloat("savegame.mod.movement.damage.amount", impactDamage)
	UiPop()

	UiTranslate(0, 60)
	if impactDamage ~= 0 then
		

		UiPush()
			UiFont("bold.ttf", 26)
			UiAlign("left left")

			UiButtonImageBox("MOD/ui/alpha.png", 5,5)
			if UiBlankButton(panelwidth, 57) then impactDamageKills = not impactDamageKills end
			UiText("Impacts Deal Lethal Damage")
			UiFont("regular.ttf", 20)
			UiTranslate(0, 20)
			UiText("When enabled, hard impacts can kill - Otherwise you will be left with low health")
			UiAlign("right")
			UiTranslate(panelwidth, 15)
			optionsLine(impactDamageKills)
			UiTranslate(0, -15)
			UiAlign("right right")
			UiFont("bold.ttf", 55)
			local txt = "disabled"
			if impactDamageKills then txt = "enabled" end
			if not impactDamageKills then UiColor(0.5,0.5,0.5) end
			UiText(txt)
			SetBool("savegame.mod.movement.damage.allowkill", impactDamageKills)
		UiPop()
	else 
		UiPush()
			UiColor(0.5,0.5,0.5, 0.5)
			UiFont("bold.ttf", 26)
			UiAlign("left left")

			UiButtonImageBox("MOD/ui/alpha.png", 5,5)
			UiText("Impacts Deal Lethal Damage")
			UiFont("regular.ttf", 20)
			UiTranslate(0, 20)
			UiText("When enabled, hard impacts can kill - Otherwise you will be left with low health")
			UiAlign("right")
			UiTranslate(panelwidth, 15)
			optionsLineGrey()
			UiTranslate(0, -15)
			UiAlign("right right")
			UiFont("bold.ttf", 55)
			local txt = "disabled"
			if impactDamageKills then txt = "enabled" end
			UiColor(0.5,0.5,0.5, 0.5)
			UiText(txt)
			SetBool("savegame.mod.movement.damage.allowkill", impactDamageKills)
		UiPop()
	end
	UiTranslate(0, 60)
	UiPush()
		UiFont("bold.ttf", 26)
		UiAlign("left left")

		UiButtonImageBox("MOD/ui/alpha.png", 5,5)
		if UiBlankButton(panelwidth, 57) then enableGP = not enableGP end
		UiText("Ground Pound")
		UiFont("regular.ttf", 20)
		UiTranslate(0, 18)
		UiText("When crouching in the air, smash down at high speeds and leave an impact")
		UiAlign("right")
		UiTranslate(panelwidth, 15)
		optionsLine(enableGP)
		UiTranslate(0, -15)
		UiAlign("right right")
		UiFont("bold.ttf", 55)
		local txt = "disabled"
		if enableGP then txt = "enabled" end
		if not enableGP then UiColor(0.5,0.5,0.5) end
		UiText(txt)
		SetBool("savegame.mod.movement.groundpound.enabled", enableGP)
	UiPop()

	UiTranslate(0, 60)
	UiPush()
		UiFont("bold.ttf", 26)
		UiAlign("left left")

		UiButtonImageBox("MOD/ui/alpha.png", 5,5)
		if UiBlankButton(panelwidth, 57) then enableRedTide = not enableRedTide end
		UiText("RedTide")
		UiFont("regular.ttf", 20)
		UiTranslate(0, 18)
		UiText("An experimental energy drink that boosts the destructive potential of the human body")
		UiAlign("right")
		UiTranslate(panelwidth, 15)
		optionsLine(enableRedTide)
		UiTranslate(0, -15)
		UiAlign("right right")
		UiFont("bold.ttf", 55)
		local txt = "disabled"
		if enableRedTide then txt = "enabled" end
		if not enableRedTide then UiColor(0.5,0.5,0.5) end
		UiText(txt)
		SetBool("savegame.mod.movement.redtide.enabled", enableRedTide)
	UiPop()
	
	UiTranslate(0, 60)
	UiPush()
		UiFont("bold.ttf", 26)
		UiAlign("left left")

		UiButtonImageBox("MOD/ui/alpha.png", 5,5)
		if UiBlankButton(panelwidth, 57) then steroidBuff = not steroidBuff end
		UiText("Improved BlueTide")
		UiFont("regular.ttf", 20)
		UiTranslate(0, 18)
		UiText("Increases the base speed of BlueTide to be closer to sliding - also increases destruction")
		UiAlign("right")
		UiTranslate(panelwidth, 15)
		optionsLine(steroidBuff)
		UiTranslate(0, -15)
		UiAlign("right right")
		UiFont("bold.ttf", 55)
		local txt = "disabled"
		if steroidBuff then txt = "enabled" end
		if not steroidBuff then UiColor(0.5,0.5,0.5) end
		UiText(txt)
		SetBool("savegame.mod.movement.redtide.enabled", steroidBuff)
	UiPop()
	
	UiTranslate(panelwidth/2, 0)
	-- Presets


end

function accent()
	UiColor(0.99, 0.73, 0.125)
end